﻿Imports System.Data.OleDb

Public Class Form1

    Dim toprow As Integer
    Dim lastrow As Integer
    Dim lastrow_visible As Integer
    Dim count As Integer

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'get the data
        Dim strSelect As String = "select * from Products"
        Dim strConn As String = GetConnectionString()
        Dim da As OleDbDataAdapter = New OleDbDataAdapter(strSelect, strConn)
        Dim dt As DataTable = New DataTable("Products")
        da.Fill(dt)

        'bind to grid
        C1FlexGrid1.DataSource = dt

        'Get the index of the Top and Bottom rows in the start and the total count of the rows available
        toprow = C1FlexGrid1.TopRow
        lastrow_visible = C1FlexGrid1.BottomRow
        count = C1FlexGrid1.Rows.Count
        lastrow = C1FlexGrid1.BottomRow

        Timer1.Start()
    End Sub

    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        'On each tick of the timer, change the index of the Top and Bottom row in the view range of the C1FlexGrid
        If lastrow <= count Then
            C1FlexGrid1.TopRow = toprow
            toprow = toprow + 1
            lastrow = lastrow + 1
        Else
            'When the scrollbar reaches the end of the flex, reset the index of TopRow visible to 1
            toprow = 1
            lastrow = lastrow_visible
            System.Threading.Thread.Sleep(100)
            C1FlexGrid1.TopRow = 1
        End If
    End Sub

    Private Sub C1FlexGrid1_AfterScroll(ByVal sender As Object, ByVal e As C1.Win.C1FlexGrid.RangeEventArgs) Handles C1FlexGrid1.AfterScroll
        'Get the index of the top row in the view range
        If e.NewRange.TopRow = e.OldRange.TopRow + 1 Then
            toprow = e.NewRange.TopRow
        Else
            toprow = e.NewRange.TopRow + 1
        End If
        'Get the index of the last row in the view range
        If e.NewRange.BottomRow <= C1FlexGrid1.Rows.Count Then
            lastrow = e.NewRange.BottomRow + 1
        End If
    End Sub

    Private Function GetConnectionString() As String
        Dim path As String = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "\ComponentOne Samples\Common"
        Dim conn As String = "provider=microsoft.jet.oledb.4.0;data source={0}\c1nwind.mdb;"
        Return String.Format(conn, path)
    End Function
End Class
